unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,softrender, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);

    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var p:array[0..5] of TVect;
var i:integer;
begin
  Image1.Picture.Bitmap.Width:=Image1.Width;
  Image1.Picture.Bitmap.Height:=Image1.Height;
  Image1.Picture.Bitmap.PixelFormat:=pf24bit;



   viewport.arr[0]:=0;
   viewport.arr[1]:=0;
   viewport.arr[2]:=Image1.Width;
   viewport.arr[3]:=Image1.Height;
   _gluPerspective(45,
                  Image1.Width / Image1.Height,
                  1, 1000);





  LoadTex('wall.jpg');
  LoadTex('height.jpg');


 BufferSetDim(Image1.Picture.Width,Image1.Picture.Height);


 p[0]:=Vector(0,0,-1);
 p[1]:=Vector(5,0,-1);
 p[2]:=Vector(5,5,-1);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,1,uv(0,0,1,0,1,1));

 p[0]:=Vector(0,0,-1);
 p[1]:=Vector(0,5,-1);
 p[2]:=Vector(5,5,-1);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,0,uv(0,0,0,1,1,1));


 for i := 0 to 50-1 do
  begin

 p[0]:=Vector(0,0,-5-i);
 p[1]:=Vector(5,0,-5-i);
 p[2]:=Vector(5,5,-5-i);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,1,uv(0,0,1,0,1,1));

 p[0]:=Vector(0,0,-5-i);
 p[1]:=Vector(0,5,-5-i);
 p[2]:=Vector(5,5,-5-i);
 p[3]:=Vector(0,0,1);
 p[4]:=Vector(0,0,1);
 p[5]:=Vector(0,0,1);
 Poly(p,0,uv(0,0,0,1,1,1));
  end;

//showmessage(floattostr(norms[1].z));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var gettickcount2:integer;
var i,k:integer;
var oldtime:integer;
var time:integer;
var fps:integer;
begin
timer1.Enabled:=false;

 BackBuffer.Bitmap.Canvas.Brush.Color:=clWhite;
repeat

 oldtime:=time;
for k := 0 to 3 do
 begin




_gluMakeIdentity(matMod);


 gettickcount2:= gettickcount;

 camera.x:=10*cos(gettickcount2/10000);
 camera.y:=0;
 camera.z:=10*sin(gettickcount2/10000);



   dxuLookAt(camera.x,camera.y,camera.z,
            0, 0, 0,
            0, 1, 0);
{

   dxuLookAt(0,0,6,
            0, 0, 0,
            0, 1, 0);
 }

dxTranslatef (-2.5,-2.5,0);

 BufferLock;







 for i := 0 to 100-1 do
// for i := 0 to 1 do
Polygon(i);


Rasterize;


 BufferUnLock;

// Image1.Picture.Assign(BackBuffer.Bitmap);

BitBlt(Canvas.Handle, 0, 0, BackBuffer.Bitmap.Width - 1,
BackBuffer.Bitmap.Height - 1, BackBuffer.Bitmap.Canvas.Handle, 0, 0,
          srccopy);


 BackBuffer.Bitmap.Canvas.FillRect(BackBuffer.Bitmap.Canvas.ClipRect);

 end;

 time:=gettickcount;
 fps:=round(4*1000/(time-oldtime));

Form1.Caption:='Engine v0.1 Software rendering 100 polygons. FPS='+inttostr(fps)+' xcount='+inttostr(xcount);
Application.ProcessMessages;
until false;

 end;






end.
